package org.hso.ecommerce.action.warehouse;

import java.sql.Timestamp;
import java.util.Date;

import org.hso.ecommerce.entities.booking.BookingReason;
import org.hso.ecommerce.entities.supplier.SupplierOrder;
import org.hso.ecommerce.entities.warehouse.WarehouseBooking;
import org.hso.ecommerce.entities.warehouse.WarehouseBookingPosition;
import org.hso.ecommerce.entities.warehouse.WarehouseBookingPositionSlotEntry;
import org.hso.ecommerce.repos.warehouse.WarehouseBookingPositionSlotEntryRepository;

public class StoreSupplierOrderAction {

	private WarehouseBookingPositionSlotEntryRepository warehouseBookingPositionSlotEntryRepository;
	private SupplierOrder order;

	public StoreSupplierOrderAction(SupplierOrder order,
			WarehouseBookingPositionSlotEntryRepository warehouseBookingPositionSlotEntryRepository) {
		this.order = order;
		this.warehouseBookingPositionSlotEntryRepository = warehouseBookingPositionSlotEntryRepository;
	}

	public WarehouseBooking storeOrder() {

		// order.delivered = new Timestamp(System.currentTimeMillis()); //TODO

		WarehouseBooking booking = new WarehouseBooking();
		booking.created = new Timestamp(new Date().getTime());
		booking.reason = new BookingReason(order);

		System.out.println(warehouseBookingPositionSlotEntryRepository);

		// loop bis alles verteilt

		// new BookingPosition

		// slot entry,

		int amount = order.numberOfUnits;

		for (WarehouseBookingPositionSlotEntry slot : warehouseBookingPositionSlotEntryRepository.findAll()) {

			System.out.println(slot.article.title);

			if (slot.article.related == order.ordered) {

				// ordered article is already in warehouse

				System.out.println("ordered article is allready in warehouse");

				if (slot.newSumSlot < slot.article.warehouseUnitsPerSlot) {

					int freeSpace = (slot.article.warehouseUnitsPerSlot - slot.newSumSlot);

					System.out.println("Slot noch frei");

					WarehouseBookingPosition bookingPosition = new WarehouseBookingPosition();

					bookingPosition.article = slot.article;
					bookingPosition.amount = Math.min(amount, freeSpace);
					bookingPosition.slotEntry = slot.copyAddAmount(Math.min(amount, freeSpace));
					bookingPosition.booking = booking;
					
					amount = amount - freeSpace;

					booking.positions.add(bookingPosition);
					
				} else {

					System.out.println("Slot voll");

				}
				
				if (amount == 0) {
                    break;
                }

			}

		} //end loop article in already 

		
		if (amount > 0) {
			
			//loop to add new slots
			
			
			
			
			
			
		}
		return booking;
		

	}

}
